EDBFrame = CreateFrame("Frame", "EDBFrame")
local Threshhold=750;
local playername=(UnitName("PLAYER"));

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB_CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB_GuildFrameUpdated() end);
			EDBFrame:UnregisterEvent("ADDON_LOADED");
		end
	elseif(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
		if(prefix=="EDB2") then
			if(msg=="request sync") then
				EDB_SYNC();
			else
				name=string.sub(msg,1,string.find(msg,":")-1);
				MS=string.sub(msg,string.find(msg,":")+1,string.find(msg,";")-1);
				OS=string.sub(msg,string.find(msg,";")+1,string.find(msg,"@")-1);
				updated=tonumber(string.sub(msg,string.find(msg,"@")+1, string.find(msg, "#")-1));
				earned=tonumber(string.sub(msg,string.find(msg,"@")+1, string.find(msg, "~")-1));
				spent=tonumber(string.sub(msg,string.find(msg,"@")+1, string.find(msg, "?")-1));
				current=tonumber(string.sub(msg,string.find(msg,"@")+1,-1));
				if(ELGOHDB[name]) then
					if(ELGOHDB[name]["updated"]<updated) then
						ELGOHDB[name]["MS"]=MS;
						ELGOHDB[name]["OS"]=OS;
						ELGOHDB[name]["updated"]=updated;
						ELGOHDB[name]["earned"]=earned;
						ELGOHDB[name]["spent"]=spent;
						ELGOHDB[name]["current"]=current;
						print("Elgoh: Updated "..name);
					end
				else
					ELGOHDB[name]={}
					ELGOHDB[name]["MS"]=MS;
					ELGOHDB[name]["OS"]=OS;
					ELGOHDB[name]["updated"]=updated;
					ELGOHDB[name]["earned"]=earned;
					ELGOHDB[name]["spent"]=spent;
					ELGOHDB[name]["current"]=current;
					print("Elgoh: Added "..name);
				end
			end
		end
	end
end

-- GL_DKPValues = {
-- ["epgp"] = 1,
-- ["gp_base"] = 0,
-- ["current_dkp_data"] = {

            -- ["aerun"] = {
                -- ["earned"] = -50.00,
                -- ["spent"] = 0.00,
                -- ["current"] = -50.00,
                -- ["last30"] = 0,
                -- ["last60"] = 0,
                -- ["guildlast30"] = 31,
                -- ["guildlast60"] = 45,        
                -- ["epgp_gp_base"] = 0.00,
                -- ["epgp_pr_base"] = -50.00,
                -- },

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function EDB_CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBMSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBMSText:SetHeight(10);
		EDBMSText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBOSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBOSText:SetHeight(10);
		EDBOSText:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		
		-- if(Elgoh_Officer()) then
			-- EDBButton=CreateFrame("Button",nil,EDBFrame,"UIMenuButtonStretchTemplate")
			-- EDBButton:RegisterForClicks("AnyUp");
			-- EDBButton:SetScript("OnShow", nil);
			-- EDBButton:SetScript("OnMouseDown", nil);
			-- EDBButton:SetScript("OnMouseUp", nil);
			-- EDBButton:SetScript("OnClick", EDB_EDIT);
			-- EDBButton:SetPoint("RIGHT", "EDBFrame", "RIGHT", -5,0);
			-- EDBButton:SetWidth(25)
			-- EDBButton:SetHeight(EDBFrame:GetHeight()-10)
			-- EDBButton:SetText("+");
		-- end
		
		EDBDKPText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("RIGHT");
		EDBDKPText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 0, -15);
		EDBDKPText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -15);
		
	end
end

function EDB_GuildFrameUpdated()
	local pname,rank= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if pname == EDB.selected then return end
		EDB.selected = pname;
		EDB_UpdateLines(pname,rank);
	end
end

function EDB_ADD(member,MS,OS)
	ELGOHDB[member]={};
	ELGOHDB[member]["MS"]=MS;
	ELGOHDB[member]["OS"]=OS;
	ELGOHDB[member]["updated"]=time();
end

function EDB_UpdateLines(who,rank)
	if(rank=="Alts" or rank=="Leader Alts" or rank=="Social Member") then EDBFrame:Hide(); return; else EDBFrame: Show(); end
	if IsShiftKeyDown() then EDB_EDIT(); end
	if(ELGOHDB[who]) then
		EDBMSText:SetText("MS: "..ELGOHDB[who]["MS"]);
		EDBOSText:SetText("OS: "..ELGOHDB[who]["OS"]);
		EDBDKPText:SetText("DKP: Yes");
		EDBDKPText:SetTextColor(0.2,1,0.2);
		if((ELGOHDB[playername]["earned"]>Threshhold and ELGOHDB[who]["earned"]>Threshhold) or (ELGOHDB[playername]["earned"]<Threshhold and ELGOHDB[who]["earned"]<Threshhold)) then
			if(ELGOHDB[who]["current"]>ELGOHDB[playername]["current"]) then
				EDBDKPText:SetText("DKP: No");
				EDBDKPText:SetTextColor(1,0.2,0.2);
			end
		elseif(ELGOHDB[playername]["earned"]<Threshhold and ELGOHDB[who]["earned"]>Threshhold) then
			EDBDKPText:SetText("DKP: No");
			EDBDKPText:SetTextColor(1,0.2,0.2);
		end
	else
		EDBMSText:SetText("No "..who);
		EDBOSText:SetText(":(");
	end
end

function EDB_Prune()
	local i,name,rank;
	for name,_ in pairs(ELGOHDB) do
		if ELGOHDB[name] then ELGOHDB[name]["flag"]=true; end
	end
	for i=0, GetNumGuildMembers(),1 do
		name, rank = GetGuildRosterInfo(i);
		if(ELGOHDB[name] and (rank~="Alts" and rank~="Leader Alts" and rank~="Social Member")) then ELGOHDB[name]["flag"]=false; end
	end
	for name,_ in pairs(ELGOHDB) do
		if ELGOHDB[name]["flag"]==true then
			ELGOHDB[name]=nil; 
			print("Elgoh: "..name.." pruned from Database"); 
		end
	end
end

function EDB_LoadValues()
	for i = 1, GetNumGuildMembers(), 1 do 
		name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
		if(ELGOHDB[name]) then
			if(GL_DKPValues["current_dkp_data"][name:lower()]) then
				ELGOHDB[name]["earned"]=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				ELGOHDB[name]["spent"]=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				ELGOHDB[name]["current"]=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
			else
				ELGOHDB[name]["earned"]=0;
				ELGOHDB[name]["spent"]=0;
				ELGOHDB[name]["current"]=0;
			end
			ELGOHDB[name]["updated"]=time();
		end
	end
	EDB_SYNC();
end

function EDB_SYNC()
	for i = 1, GetNumGuildMembers(), 1 do 
		local name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
		if(ELGOHDB[name]) then
			SendAddonMessage("EDB2", name..":"..ELGOHDB[name]["MS"]..";"..ELGOHDB[name]["OS"].."@"..ELGOHDB[name]["updated"].."#"..ELGOHDB[name]["earned"].."~"..ELGOHDB[name]["spent"].."?"..ELGOHDB[name]["current"], "GUILD");
		end
	end
end

function EDB_EDIT()
EditingName=GetGuildRosterInfo(GetGuildRosterSelection());
editmembername:SetText("Editing "..EditingName);
if(ELGOHDB[EditingName]) then
	EDBNewMS:SetText(ELGOHDB[EditingName]["MS"])
	EDBNewOS:SetText(ELGOHDB[EditingName]["OS"])
else
	EDBNewMS:SetText("No "..EditingName);
	EDBNewOS:SetText(":(");
end
	frmEDBADD:Show();
end

function EDB_Report(Short)
	local MSTanks=0;
	local MSHeals=0;
	local MSMelee=0;
	local MSRanged=0;
	local OSTanks=0;
	local OSHeals=0;
	local OSMelee=0;
	local OSRanged=0;
	local NID=0;

	for i = 1, GetNumGuildMembers(), 1 do 
	if(Short) then
		name, rank, rankIndex, level,_,_,_,_, online = GetGuildRosterInfo(i);
	else
		name, rank, rankIndex, level= GetGuildRosterInfo(i);
		online=1;
	end
		if(rank~="Alts" and rank~="Leader Alts" and level==85 and online) then
			if(ELGOHDB[name]) then
				if(ELGOHDB[name]["MS"]=="Tank") then MSTanks=MSTanks+1; end
				if(ELGOHDB[name]["MS"]=="Healer") then MSHeals=MSHeals+1; end
				if(ELGOHDB[name]["MS"]=="Ranged DPS") then MSRanged=MSRanged+1; end
				if(ELGOHDB[name]["MS"]=="Melee DPS") then MSMelee=MSMelee+1; end
				
				if(ELGOHDB[name]["OS"]=="Tank") then OSTanks=OSTanks+1; end
				if(ELGOHDB[name]["OS"]=="Healer") then OSHeals=OSHeals+1; end
				if(ELGOHDB[name]["OS"]=="Ranged DPS") then OSRanged=OSRanged+1; end
				if(ELGOHDB[name]["OS"]=="Melee DPS") then OSMelee=OSMelee+1; end
			else
				NID=NID+1;
			end
		end
	end
	if(Short==1) then
		PostTo("Online Spec Report:");
	else
		PostTo("Full Spec Report:");
		PostTo("("..NID.." characters weren't in the database)");
		PostTo(" ");
	end
	PostTo("Tanks: "..MSTanks);
	PostTo("Healers: "..MSHeals);
	if(MSRanged==1) then word="is"; else word="are"; end
	if(Short==1) then
		PostTo("DPS: "..(MSRanged+MSMelee).." ("..MSRanged.." "..word.." Ranged)")
	else
		PostTo("DPS: "..(MSRanged+MSMelee).." ["..MSRanged.." ("..string.format("%.0f",((MSRanged/(MSRanged+MSMelee))*100)).."%) "..word.." Ranged]")
		PostTo(" ");
		PostTo("Offspec Tanks: "..OSTanks);
		PostTo("Offspec Healers: "..OSHeals);
		PostTo("Offspec DPS: "..(OSRanged+OSMelee).." ["..MSRanged.." ("..string.format("%.0f",((OSRanged/(OSRanged+OSMelee))*100)).."%) "..word.." Ranged]")
	end
--	PostTo("Not including Alts or Officer Alts");
end

function EDB_Handle(self,button)
	if(button=="RightButton") then
		if(self:GetName()=="btnMSTank") then EDBNewOS:SetText("Tank"); end
		if(self:GetName()=="btnMSMelee") then EDBNewOS:SetText("Melee DPS"); end
		if(self:GetName()=="btnMSRanged") then EDBNewOS:SetText("Ranged DPS"); end
		if(self:GetName()=="btnMSHealer") then EDBNewOS:SetText("Healer"); end
	else
		if(self:GetName()=="btnMSTank") then EDBNewMS:SetText("Tank"); end
		if(self:GetName()=="btnMSMelee") then EDBNewMS:SetText("Melee DPS"); end
		if(self:GetName()=="btnMSRanged") then EDBNewMS:SetText("Ranged DPS"); end
		if(self:GetName()=="btnMSHealer") then EDBNewMS:SetText("Healer"); end
	end
end
